﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DynamicLoad;

namespace DynamicLoadDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private static AssemblyLoader _Loader = null;
        private static AssemblyLoader Loader
        {
            get
            {
                if (_Loader == null)
                {
                    _Loader = new AssemblyLoader();
                    Dictionary<string, string> dict = new Dictionary<string, string>();
                    dict.Add("YuNing.TestLibrary.dll", "YuNing.TestLibrary.HelloWordService");
                    _Loader.LoadAssemblys(dict);
                }
                return _Loader;
            }
        }

        private object Hello(string inputString)
        {
            return Loader.InvokeMethod("YuNing.TestLibrary.dll", "Hello", new[] { inputString });
        }


        private void btnTest_Click(object sender, EventArgs e)
        {
            string inputString = this.txtInput.Text.Trim();
            if (string.IsNullOrEmpty(inputString))
            {
                this.txtOutput.AppendText("请输入");
                this.txtOutput.AppendText(Environment.NewLine);
                return;
            }

            try
            {
                object obj = Hello(inputString);
                string outputString = obj != null ? obj.ToString() : "null";

                this.txtOutput.AppendText("输出：" + outputString);
                this.txtOutput.AppendText(Environment.NewLine);
            }
            catch (Exception ex)
            {
                this.txtOutput.AppendText("异常：" + ex.Message);
                this.txtOutput.AppendText(Environment.NewLine);
            }

        }
    }
}
